#pragma once
#include <windows.h>
#include "WiiRemoteConvert.h"
#include <iostream>

class WiiBalanceBoardConvert : public WiiRemoteConvert
{
private:
	double GetBalanceBoardSensorValue(int sensor, int min, int mid, int max);

public:
	WiiBalanceBoardConvert(void);
	~WiiBalanceBoardConvert(void);

	struct Point
	{
		int X;
		int Y;
	};

	struct WiiBalanceBoardSensors
	{
		int TopRight;
		int TopLeft;
		int BottomRight;
		int BottomLeft;
	};

	struct WiiBalanceBoardSensorsF
	{
		double TopRight;
		double TopLeft;
		double BottomRight;
		double BottomLeft;
	};

	struct WiiBalanceBoardCalibrationInfo
	{
		WiiBalanceBoardSensors Kg0;
		WiiBalanceBoardSensors Kg17;
		WiiBalanceBoardSensors Kg34;
	};

	struct WiiBalanceBoardParameter
	{
		WiiBalanceBoardCalibrationInfo CalibrationInfo;
		WiiBalanceBoardSensors SensorValuesRaw;
		WiiBalanceBoardSensorsF SensorValuesKg;
		Point CenterOfGravity;
		double WeightKg;
	};

	WiiBalanceBoardParameter BalanceBoardState;
	void SetWiiExtensionCalibration(BYTE *buff);
	void ParseExtension(BYTE* buff);
};
