#pragma once
#include "wiiremoteconvert.h"

class WiiMotionPlusConvert :
	public WiiRemoteConvert
{
public:
	WiiMotionPlusConvert(void);
	~WiiMotionPlusConvert(void);

	struct MotionPlusRaw
	{
		short yaw;
		short pitch;
		short roll;
	};

	struct MotionPlusSpeed
	{
		short yaw_Speed;
		short pitch_Speed;
		short roll_Speed;
	};

	struct AverageCalib{
		short yaw0;
		short pitch0;
		short roll0;
	};

	struct MotionPlusParameter
	{
		MotionPlusRaw gyro;
		MotionPlusSpeed gyro_speed;
		AverageCalib AveCalib;
	};

	MotionPlusParameter mMotionPlusState;
	void ParseExtension(BYTE* buff);
	void ParseMotionPlusCalib(BYTE* buff, int loop);

private:
	short yaw_old;
	short pitch_old;
	short roll_old;
};
