#include "WiiRemoteCntl.h"

CWiiRemoteCntl::CWiiRemoteCntl(void){
	ZeroMemory( &overlapped, sizeof(OVERLAPPED));
}

CWiiRemoteCntl::~CWiiRemoteCntl(void){
}

GUID* CWiiRemoteCntl::GetHidGuid(void){
	guid = new GUID;
	//HID̏Zbg
	HidD_GetHidGuid( guid );
	return guid;
}

PSP_INTERFACE_DEVICE_DETAIL_DATA CWiiRemoteCntl::GetHidDeviceDetail( GUID* guid, int index){
	//HIDNX̃foCX񋓂ꂽXgւ̃nh擾
	HDEVINFO DeviceInfo = SetupDiGetClassDevs(guid, NULL, NULL,(DIGCF_PRESENT | DIGCF_DEVICEINTERFACE));

	SP_DEVICE_INTERFACE_DATA* DeviceInterface = new SP_DEVICE_INTERFACE_DATA;
	DeviceInterface->cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);

	//Xg̐擪珇HIDNXfoCX̏擾
	if( !SetupDiEnumDeviceInterfaces( DeviceInfo, NULL, guid, index, DeviceInterface)){
		SetupDiDestroyDeviceInfoList(DeviceInfo);
		return NULL;
	}

	unsigned long size;
	//foCX̏ڍ׏񂩂windows̃foCX擾
	SetupDiGetDeviceInterfaceDetail( DeviceInfo, DeviceInterface, NULL, 0, &size, 0);

	PSP_INTERFACE_DEVICE_DETAIL_DATA DeviceDetail = PSP_INTERFACE_DEVICE_DETAIL_DATA( new char[size]);
	DeviceDetail->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);

	if( !SetupDiGetDeviceInterfaceDetail( DeviceInfo, DeviceInterface, DeviceDetail, size, &size, NULL)){
		return NULL;
	}
	return DeviceDetail;
}

bool CWiiRemoteCntl::FindWiiRemote(void){

	std::cout << std::hex;
	GetHidGuid();
	devNum = 0;
	for( int index = 0; ; index++){

		DeviceDetail = GetHidDeviceDetail(guid, index);

		if(DeviceDetail == NULL){
			return false;
		}

		std::cout << DeviceDetail->DevicePath << std::endl;


		//HIDfoCXI[vt@Cnh擾
		handle = CreateFile(DeviceDetail->DevicePath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE, NULL,OPEN_EXISTING,0,NULL);
		if(handle ==INVALID_HANDLE_VALUE){
			std::cerr <<"ACCESS DENIED..."<<std::endl;
			continue;
		}

		HIDD_ATTRIBUTES attr;

		//HIDfoCX̑擾
		if( !HidD_GetAttributes(handle, &attr)){
			continue;
		}

		std::cout << "VendorID: " << attr.VendorID << std::endl;
		std::cout << "ProductID: " << attr.ProductID << std::endl;

		//xnhĂHIDfoCXN[Y
		CloseHandle( handle );
		devNum = index;
		//{ΏۂHIDfoCXVendorIDProductID𗘗pĔf
		if( attr.VendorID != 0x057e || attr.ProductID != 0x0306){
			continue;
		}
		break;
	}

	DeviceDetail = GetHidDeviceDetail(guid, devNum);

	//Ώۂ̃foCXꍇCHIDfoCXI[v
	handle = CreateFile(DeviceDetail->DevicePath,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE, NULL,OPEN_EXISTING,0,NULL);
	if(handle == INVALID_HANDLE_VALUE ){
		std::cerr << "cannot reopen device..." <<std::endl;
	}

	PHIDP_PREPARSED_DATA pp;
	//HIDfoCX̔\͂擾C_EpCvƃAbvpCṽf[^TCY擾
	if(!HidD_GetPreparsedData(handle, &pp)){
		std::cerr << "cannot get preparsed data..." << std::endl;
		return false;
	}
	if(HidP_GetCaps(pp, &caps) != HIDP_STATUS_SUCCESS ){
		std::cerr << "cannot get caps..." <<std::endl;
	}

	return true;
}

bool CWiiRemoteCntl::WriteReport(BYTE *outputReport){

	if(!WriteFile(handle,outputReport,caps.OutputReportByteLength,&count,&overlapped)){
		if(GetLastError() != ERROR_IO_PENDING && GetLastError() != ERROR_IO_INCOMPLETE){
			std::cerr << "failed to write data from the device..." << GetLastError() << std::endl;
			return false;
		}
		//nhɊ֌W钼Ȍǂ
		while(true){
			if(GetOverlappedResult(handle,&overlapped, &count ,true)){
				break;
			}
		}
	}

	return true;
}

bool CWiiRemoteCntl::ReadReport(BYTE *inputReport,int *len){

	ReadFile(handle,inputReport,caps.InputReportByteLength,&count,&overlapped);
	while(true){
		//nhɊ֌W钼Ȍǂ
		if(GetOverlappedResult(handle, &overlapped, &count,FALSE)){
			*len = caps.InputReportByteLength;
			break;
		}
		else{
			if(GetLastError() != ERROR_IO_PENDING && GetLastError() != ERROR_IO_INCOMPLETE){
				std::cerr << "failed to read data from the device..." << GetLastError() << std::endl;
				return false;
			}
		}
	}
	return true;
}

BYTE* CWiiRemoteCntl::ReadReport(){

	ReadFile(handle,&inputReport,caps.InputReportByteLength,&count,&overlapped);
	while(true){
		//nhɊ֌W钼Ȍǂ
		if(GetOverlappedResult(handle, &overlapped, &count,FALSE)){
			break;
		}
		else{
			if(GetLastError() != ERROR_IO_PENDING && GetLastError() != ERROR_IO_INCOMPLETE){
				std::cerr << "failed to read data from the device..." << GetLastError() << std::endl;
				return false;
			}
		}
	}
	return this->inputReport;
}

bool CWiiRemoteCntl::WiiClosed(void){
	CloseHandle(handle);
	return true;
}

bool CWiiRemoteCntl::Report_0x12(BYTE data1, BYTE data2){
	BYTE outputReport[22];
	ZeroMemory(&outputReport, sizeof(outputReport));

	outputReport[0] = 0x12;
	outputReport[1] = data1;
	outputReport[2] = data2;
	return WriteReport(outputReport);
}

void CWiiRemoteCntl::WriteData(int address, int data){
	BYTE outputReport[22];
	ZeroMemory(&outputReport, sizeof(outputReport));

	outputReport[0] = 0x16;
	outputReport[1] = ((address & 0xff000000) >> 24);
	outputReport[2] = ((address & 0x00ff0000) >> 16);
	outputReport[3] = ((address & 0x0000ff00) >>  8);
	outputReport[4] = (address & 0x000000ff);
	outputReport[5] = 0x01;
	outputReport[6] = data;
	WriteReport(outputReport);
}

void CWiiRemoteCntl::DebugWriteLine(BYTE* dispBuff, int displaySize){
	int j = 0;
	for(int i = 0 ; i < displaySize ; i++)
	{
		int buff = dispBuff[i];
		std::cout << std::hex << buff << " ";
		if(j % 21 == 0 && j != 0)
		{
			std::cout << std::endl;
			j = -1;
		}
		j++;
	}
	std::cout << std::endl;
}

bool CWiiRemoteCntl::GetStatus(void){
	BYTE outputReport[22];
	ZeroMemory(&outputReport, sizeof(outputReport));

	outputReport[0] = 0x15;
	outputReport[1] = LEDandVibrationCommand;
	
	return WriteReport(outputReport);
}

